KZip Class Reference

`#include <kzip.h>`

Inheritance diagram for KZip:

## Public Types

enum | ExtraField { NoExtraField = 0, ModificationTime = 1, DefaultExtraField = 1 }
enum | Compression { NoCompression = 0, DeflateCompression = 1 }

## Public Member Functions

| KZip (const QString &filename)
| KZip (QIODevice *dev)
virtual | ~KZip ()
QString | fileName ()
void | setExtraField (ExtraField ef)
ExtraField | extraField () const
void | setCompression (Compression c)
Compression | compression () const
virtual bool | writeFile (const QString &name, const QString &user, const QString &group, uint size, const char *data)
virtual bool | prepareWriting (const QString &name, const QString &user, const QString &group, uint size)
bool | writeSymLink (const QString &name, const QString &target, const QString &user, const QString &group, mode_t perm, time_t atime, time_t mtime, time_t ctime)
bool | prepareWriting (const QString &name, const QString &user, const QString &group, uint size, mode_t perm, time_t atime, time_t mtime, time_t ctime)
bool | writeFile (const QString &name, const QString &user, const QString &group, uint size, mode_t perm, time_t atime, time_t mtime, time_t ctime, const char *data)
bool | writeData (const char *data, uint size)
virtual bool | doneWriting (uint size)
Public Member Functions inherited from KArchive
virtual bool | open (int mode)
virtual void | close ()
bool | closeSucceeded () const
bool | isOpened () const
int | mode () const
QIODevice * | device () const
const KArchiveDirectory * | directory () const
bool | addLocalFile (const QString &fileName, const QString &destName)
bool | addLocalDirectory (const QString &path, const QString &destName)
bool | writeDir (const QString &name, const QString &user, const QString &group, mode_t perm, time_t atime, time_t mtime, time_t ctime)
bool | writeSymLink (const QString &name, const QString &target, const QString &user, const QString &group, mode_t perm, time_t atime, time_t mtime, time_t ctime)
bool | writeFile (const QString &name, const QString &user, const QString &group, uint size, mode_t perm, time_t atime, time_t mtime, time_t ctime, const char *data)
bool | prepareWriting (const QString &name, const QString &user, const QString &group, uint size, mode_t perm, time_t atime, time_t mtime, time_t ctime)
bool | writeData (const char *data, uint size)

## Protected Member Functions

virtual bool | openArchive (int mode)
virtual bool | closeArchive ()
virtual bool | writeDir (const QString &name, const QString &user, const QString &group)
virtual void | virtual_hook (int id, void *data)
bool | writeData_impl (const char *data, uint size)
bool | prepareWriting_impl (const QString &name, const QString &user, const QString &group, uint size, mode_t perm, time_t atime, time_t mtime, time_t ctime)
bool | writeSymLink_impl (const QString &name, const QString &target, const QString &user, const QString &group, mode_t perm, time_t atime, time_t mtime, time_t ctime)
Protected Member Functions inherited from KArchive
| KArchive (QIODevice *dev)
virtual KArchiveDirectory * | rootDir ()
KArchiveDirectory * | findOrCreate (const QString &path)
void | setDevice (QIODevice *dev)
void | setRootDir (KArchiveDirectory *rootDir)
bool | prepareWriting_impl (const QString &name, const QString &user, const QString &group, uint size, mode_t perm, time_t atime, time_t mtime, time_t ctime)
bool | writeFile_impl (const QString &name, const QString &user, const QString &group, uint size, mode_t perm, time_t atime, time_t mtime, time_t ctime, const char *data)
bool | writeDir_impl (const QString &name, const QString &user, const QString &group, mode_t perm, time_t atime, time_t mtime, time_t ctime)
bool | writeSymLink_impl (const QString &name, const QString &target, const QString &user, const QString &group, mode_t perm, time_t atime, time_t mtime, time_t ctime)
bool | writeData_impl (const char *data, uint size)

## Additional Inherited Members

Protected Types inherited from KArchive
enum | { VIRTUAL_WRITE_DATA = 1, VIRTUAL_WRITE_SYMLINK, VIRTUAL_WRITE_DIR, VIRTUAL_WRITE_FILE, VIRTUAL_PREPARE_WRITING }

## Detailed Description

This class implements a kioslave to access zip files from KDE.

You can use it in IO_ReadOnly or in IO_WriteOnly mode, and it behaves just as expected. It can also be used in IO_ReadWrite mode, in this case one can append files to an existing zip archive. When you append new files, which are not yet in the zip, it works as expected, i.e. the files are appended at the end. When you append a file, which is already in the file, the reference to the old file is dropped and the new one is added to the zip - but the old data from the file itself is not deleted, it is still in the zipfile. so when you want to have a small and garbage-free zipfile, just read the contents of the appended zip file and write it to a new one in IO_WriteOnly mode. This is especially important when you don't want to leak information of how intermediate versions of files in the zip were looking. For more information on the zip fileformat go to http://www.pkware.com/products/enterprise/white_papers/appnote.html A class for reading/writing zip archives.

Author
  Holger Schroeder holge.nosp@m.r-kd.nosp@m.e@hol.nosp@m.gis..nosp@m.net

Since
  3.1

Definition at line 53 of file kzip.h.

## Member Enumeration Documentation

enum KZip::Compression

Describes the compression type for a given file in the Zip archive.

Enumerator
NoCompression | Uncompressed.
DeflateCompression | Deflate compression method.

Definition at line 112 of file kzip.h.

enum KZip::ExtraField

Describes the contents of the "extra field" for a given file in the Zip archive.

Enumerator
NoExtraField | No extra field.
ModificationTime | Modification time ("extended timestamp" header)

Definition at line 89 of file kzip.h.

## Constructor & Destructor Documentation

KZip::KZip | ( | const QString & | filename | ) |

Creates an instance that operates on the given filename.

using the compression filter associated to given mimetype.

Parameters

  filename | is a local path (e.g. "/home/holger/myfile.zip")

Definition at line 335 of file kzip.cpp.

KZip::KZip | ( | QIODevice * | dev | ) |

Creates an instance that operates on the given device.

The device can be compressed (KFilterDev) or not (QFile, etc.).

Warning
  Do not assume that giving a QFile here will decompress the file, in case it's compressed!

Parameters

  dev | the device to access

Definition at line 347 of file kzip.cpp.

KZip::~KZip | ( |  | ) |

virtual

If the zip file is still opened, then it will be closed automatically by the destructor.

Definition at line 354 of file kzip.cpp.

## Member Function Documentation

bool KZip::closeArchive | ( |  | ) |

protected virtual

Closes the archive.

Implements KArchive.

Definition at line 855 of file kzip.cpp.

KZip::Compression KZip::compression | ( |  | ) | const

The current compression mode that will be used for new files.

Returns
  the current compression mode

See also
  setCompression()

Definition at line 1399 of file kzip.cpp.

bool KZip::doneWriting | ( | uint | size | ) |

virtual

Write data to a file that has been created using prepareWriting().

Parameters

  size | the size of the file

Returns
  true if successful, false otherwise

Implements KArchive.

Definition at line 1264 of file kzip.cpp.

KZip::ExtraField KZip::extraField | ( |  | ) | const

The current type of "extra field" that will be used for new files.

Returns
  the current type of "extra field"

See also
  setExtraField()

Definition at line 1409 of file kzip.cpp.

QString KZip::fileName | ( |  | ) |

inline

The name of the zip file, as passed to the constructor.

Null if you used the QIODevice constructor.

Returns
  the zip's file name, or null if a QIODevice is used

Definition at line 84 of file kzip.h.

bool KZip::openArchive | ( | int | mode | ) |

protected virtual

Opens the archive for reading.

Parses the directory listing of the archive and creates the KArchiveDirectory/KArchiveFile entries.

Parameters

  mode | the mode of the file

Implements KArchive.

Definition at line 369 of file kzip.cpp.

bool KZip::prepareWriting | ( | const QString & | name,
|  | const QString & | user,
|  | const QString & | group,
|  | uint | size
| ) |  |

virtual

Alternative method for writing: call prepareWriting(), then feed the data in small chunks using writeData(), and call doneWriting() when done.

Parameters

  name | can include subdirs e.g. path/to/the/file
  user | the user owning the file
  group | the group owning the file
  size | unused argument

Returns
  true if successful, false otherwise

Implements KArchive.

Definition at line 1073 of file kzip.cpp.

void KZip::setCompression | ( | Compression | c | ) |

Call this before writeFile or prepareWriting, to define whether the next files to be written should be compressed or not.

Parameters

  c | the new compression mode

See also
  compression()

Definition at line 1394 of file kzip.cpp.

void KZip::setExtraField | ( | ExtraField | ef | ) |

Call this before writeFile or prepareWriting, to define what the next file to be written should have in its extra field.

Parameters

  ef | the type of "extra field"

See also
  extraField()

Definition at line 1404 of file kzip.cpp.

bool KZip::writeData | ( | const char * | data,
|  | uint | size
| ) |  |

Write data to a file that has been created using prepareWriting().

Parameters

  data | a pointer to the data
  size | the size of the chunk

Returns
  true if successful, false otherwise

Definition at line 1368 of file kzip.cpp.

virtual bool KZip::writeDir | ( | const QString & | name,
|  | const QString & | user,
|  | const QString & | group
| ) |  |

inline protected virtual

If an archive is opened for writing then you can add new directories using this function.

KArchive won't write one directory twice.

Parameters

  name | the name of the directory
  user | the user that owns the directory
  group | the group that owns the directory

Todo:
  TODO(BIC): make this a thin wrapper around writeDir(name,user,group,perm,atime,mtime,ctime) or eliminate it

Implements KArchive.

Definition at line 197 of file kzip.h.

bool KZip::writeFile | ( | const QString & | name,
|  | const QString & | user,
|  | const QString & | group,
|  | uint | size,
|  | const char * | data
| ) |  |

virtual

If an archive is opened for writing then you can add a new file using this function.

This method takes the whole data at once.

Parameters

  name | can include subdirs e.g. path/to/the/file
  user | the user owning the file
  group | the group owning the file
  size | the size of the file
  data | a pointer to the data

Returns
  true if successful, false otherwise

Reimplemented from KArchive.

Definition at line 1055 of file kzip.cpp.

The documentation for this class was generated from the following files:

- kzip.h
- kzip.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys